Index: trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionArchives.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionArchives.java	(revision 10726)
+++ trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionArchives.java	(revision 10726)
@@ -0,0 +1,148 @@
+package org.greenstone.gatherer.remote;
+
+import java.io.*;
+import java.util.zip.*;
+import org.greenstone.gatherer.util.ZipTools;
+
+
+/**
+ */
+public class ZipCollectionArchives
+{
+    static public void main(String[] args)
+    {
+	if (args.length != 3) {
+	    System.err.println("Usage: ZipCollectionArchives <zip-file> <collect-directory-path> <collection-name>");
+	    return;
+	}
+
+	String zip_file_path = args[0];
+	String collect_directory_path = args[1];
+	String collection_name = args[2];
+
+	if (!collect_directory_path.endsWith(File.separator)) {
+	    collect_directory_path += File.separator;
+	}
+
+ 	try {
+	    ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zip_file_path));
+
+	    // Add archives directory, with doc.xml files only
+	    String archives_relative_path = collection_name + File.separator + "archives";
+	    ZipTools.ZipFilter collection_archives_zip_filter = new CollectionArchivesZipFilter();
+	    ZipTools.addFileToZip(zos, collect_directory_path, archives_relative_path, collection_archives_zip_filter);
+
+	    zos.close();
+	}
+	catch (Exception exception) {
+	    exception.printStackTrace();
+	}
+    }
+
+
+    static public class CollectionArchivesZipFilter
+	extends ZipTools.NullZipFilter
+    {
+	private byte[] bytes_remaining = new byte[0];
+	private int section_depth = 0;
+	private boolean in_section_content = false;
+
+
+	public boolean shouldIncludeFile(String relative_file_path)
+	{
+	    // Only doc.xml files are included
+	    return (relative_file_path.equals("doc.xml") || relative_file_path.endsWith(File.separator + "doc.xml"));
+	}
+
+
+	public int filterFileContent(BufferedInputStream bis, byte[] data, int bytes_to_read)
+	{
+	    try {
+		// Read the next chunk of bytes from the file
+		byte[] bytes_read_this_time = new byte[bytes_to_read];
+		int num_bytes_read_this_time = bis.read(bytes_read_this_time, 0, bytes_to_read);
+		if (num_bytes_read_this_time == -1) {
+		    // We must be at the end of the file
+		    return -1;
+		}
+
+		// Add this chunk to the bytes remaining from last time
+		byte[] bytes_unprocessed = new byte[bytes_remaining.length + num_bytes_read_this_time];
+		for (int i = 0; i < bytes_remaining.length; i++) {
+		    bytes_unprocessed[i] = bytes_remaining[i];
+		}
+		for (int i = 0; i < num_bytes_read_this_time; i++) {
+		    bytes_unprocessed[bytes_remaining.length + i] = bytes_read_this_time[i];
+		}
+
+		// Split the chunk into lines and filter them
+		int num_bytes_processed = 0;
+		int num_bytes_unfiltered = 0;
+		int last_line_start = 0;
+		for (int i = 0; (i < bytes_unprocessed.length && num_bytes_unfiltered < bytes_to_read); i++) {
+		    // Found the end of a line
+		    if (bytes_unprocessed[i] == '\n') {
+			int line_length = i - last_line_start + 1;
+			String line = new String(bytes_unprocessed, last_line_start, line_length);
+
+			// If this line isn't filtered, write it to the data array
+			if (!filterFileLine(line)) {
+			    for (int j = 0; (j < line_length && num_bytes_unfiltered < bytes_to_read); j++) {
+				data[num_bytes_unfiltered] = bytes_unprocessed[last_line_start + j];
+				num_bytes_unfiltered++;
+				num_bytes_processed++;
+			    }
+			}
+			// Otherwise ignore it
+			else {
+			    num_bytes_processed = i + 1;
+			}
+
+			last_line_start = i + 1;
+		    }
+		}
+
+		// Create a new byte array containing any bytes remaining (these will be processed next time)
+		int num_bytes_remaining = bytes_unprocessed.length - num_bytes_processed;
+		bytes_remaining = new byte[num_bytes_remaining];
+		for (int i = 0; i < num_bytes_remaining; i++) {
+		    bytes_remaining[i] = bytes_unprocessed[num_bytes_processed + i];
+		}
+
+		return num_bytes_unfiltered;
+	    }
+	    catch (Exception exception) {
+		exception.printStackTrace();
+	    }
+
+	    return -1;
+	}
+
+
+	private boolean filterFileLine(String line)
+	{
+	    boolean filter_line = false;
+
+	    if (line.indexOf("<Section>") != -1) {
+		section_depth++;
+	    }
+	    if (line.indexOf("<Content>") != -1) {
+		in_section_content = true;
+	    }
+
+	    // If we're in a subsection or in a content element, filter this line
+	    if (section_depth > 1 || in_section_content) {
+		filter_line = true;
+	    }
+
+	    if (line.indexOf("</Content>") != -1) {
+		in_section_content = false;
+	    }
+	    if (line.indexOf("</Section>") != -1) {
+		section_depth--;
+	    }
+
+	    return filter_line;
+	}
+    }
+}
Index: trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionConfigurations.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionConfigurations.java	(revision 10726)
+++ trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionConfigurations.java	(revision 10726)
@@ -0,0 +1,72 @@
+package org.greenstone.gatherer.remote;
+
+import java.io.*;
+import java.util.zip.*;
+import org.greenstone.gatherer.util.ZipTools;
+
+
+/**
+ */
+public class ZipCollectionConfigurations
+{
+    static public void main(String[] args)
+    {
+	if (args.length != 2) {
+	    System.err.println("Usage: ZipCollectionConfigurations <zip-file> <collect-directory-path>");
+	    return;
+	}
+
+	String zip_file_path = args[0];
+	String collect_directory_path = args[1];
+
+	if (!collect_directory_path.endsWith(File.separator)) {
+	    collect_directory_path += File.separator;
+	}
+	File collect_directory = new File(collect_directory_path);
+
+ 	try {
+	    ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zip_file_path));
+	    ZipTools.ZipFilter collection_etc_zip_filter = new CollectionEtcZipFilter();
+	    ZipTools.ZipFilter collection_metadata_zip_filter = new CollectionMetadataZipFilter();
+
+	    // Add the etc and metadata directories from each of the collections
+	    File[] collection_directories = collect_directory.listFiles();
+	    for (int i = 0; i < collection_directories.length; i++) {
+		if (collection_directories[i].isDirectory()) {
+		    String etc_relative_path = collection_directories[i].getName() + File.separator + "etc";
+		    ZipTools.addFileToZip(zos, collect_directory_path, etc_relative_path, collection_etc_zip_filter);
+
+		    String metadata_relative_path = collection_directories[i].getName() + File.separator + "metadata";
+		    ZipTools.addFileToZip(zos, collect_directory_path, metadata_relative_path, collection_metadata_zip_filter);
+		}
+	    }
+
+	    zos.close();
+	}
+	catch (Exception exception) {
+	    exception.printStackTrace();
+	}
+    }
+
+
+    static private class CollectionEtcZipFilter
+	extends ZipTools.NullZipFilter
+    {
+	public boolean shouldIncludeFile(String relative_file_path)
+	{
+	    // Only collect.cfg files are included
+	    return (relative_file_path.equals("collect.cfg") || relative_file_path.endsWith(File.separator + "collect.cfg"));
+	}
+    }
+
+
+    static private class CollectionMetadataZipFilter
+	extends ZipTools.NullZipFilter
+    {
+	public boolean shouldIncludeFileContent(String relative_file_path)
+	{
+	    // We don't include content for any of the metadata set files
+	    return false;
+	}
+    }
+}
Index: trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionShell.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionShell.java	(revision 10726)
+++ trunk/gli/src/org/greenstone/gatherer/remote/ZipCollectionShell.java	(revision 10726)
@@ -0,0 +1,74 @@
+package org.greenstone.gatherer.remote;
+
+import java.io.*;
+import java.util.zip.*;
+import org.greenstone.gatherer.util.ZipTools;
+
+
+/**
+ */
+public class ZipCollectionShell
+{
+    static public void main(String[] args)
+    {
+	if (args.length != 3) {
+	    System.err.println("Usage: ZipCollectionShell <zip-file> <collect-directory-path> <collection-name>");
+	    return;
+	}
+
+	String zip_file_path = args[0];
+	String collect_directory_path = args[1];
+	String collection_name = args[2];
+
+	if (!collect_directory_path.endsWith(File.separator)) {
+	    collect_directory_path += File.separator;
+	}
+
+ 	try {
+	    ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(zip_file_path));
+	    ZipTools.ZipFilter null_zip_filter = new ZipTools.NullZipFilter();
+
+	    // Add archives directory, with doc.xml files only
+	    String archives_relative_path = collection_name + File.separator + "archives";
+	    ZipTools.ZipFilter collection_archives_zip_filter = new ZipCollectionArchives.CollectionArchivesZipFilter();
+	    ZipTools.addFileToZip(zos, collect_directory_path, archives_relative_path, collection_archives_zip_filter);
+
+	    // Add etc/collect.cfg file
+	    String collect_cfg_relative_path = collection_name + File.separator + "etc" + File.separator + "collect.cfg";
+	    ZipTools.addFileToZip(zos, collect_directory_path, collect_cfg_relative_path, null_zip_filter);
+
+	    // Add images directory
+	    String images_relative_path = collection_name + File.separator + "images";
+	    ZipTools.addFileToZip(zos, collect_directory_path, images_relative_path, null_zip_filter);
+
+	    // Add import directory, with zero-length files except for metadata.xml
+	    String import_relative_path = collection_name + File.separator + "import";
+	    ZipTools.ZipFilter collection_import_zip_filter = new CollectionImportZipFilter();
+	    ZipTools.addFileToZip(zos, collect_directory_path, import_relative_path, collection_import_zip_filter);
+
+	    // Add index/build.cfg file
+	    String build_cfg_relative_path = collection_name + File.separator + "index" + File.separator + "build.cfg";
+	    ZipTools.addFileToZip(zos, collect_directory_path, build_cfg_relative_path, null_zip_filter);
+
+	    // Add metadata directory
+	    String metadata_relative_path = collection_name + File.separator + "metadata";
+	    ZipTools.addFileToZip(zos, collect_directory_path, metadata_relative_path, null_zip_filter);
+
+	    zos.close();
+	}
+	catch (Exception exception) {
+	    exception.printStackTrace();
+	}
+    }
+
+
+    static private class CollectionImportZipFilter
+	extends ZipTools.NullZipFilter
+    {
+	public boolean shouldIncludeFileContent(String relative_file_path)
+	{
+	    // We only include file content for metadata.xml files
+	    return (relative_file_path.equals("metadata.xml") || relative_file_path.endsWith(File.separator + "metadata.xml"));
+	}
+    }
+}
Index: trunk/gli/src/org/greenstone/gatherer/remote/ZipFiles.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/remote/ZipFiles.java	(revision 10726)
+++ trunk/gli/src/org/greenstone/gatherer/remote/ZipFiles.java	(revision 10726)
@@ -0,0 +1,29 @@
+package org.greenstone.gatherer.remote;
+
+import java.io.File;
+import java.util.ArrayList;
+import org.greenstone.gatherer.util.ZipTools;
+
+
+/**
+ */
+public class ZipFiles
+{
+    static public void main(String[] args)
+    {
+	if (args.length < 3) {
+	    System.err.println("Usage: ZipFiles <zip-file> <base-directory-path> (<files> ...)");
+	    return;
+	}
+
+	String zip_file_path = args[0];
+	String base_directory_path = args[1];
+	ArrayList relative_file_paths_list = new ArrayList();
+	for (int i = 2; i < args.length; i++) {
+	    relative_file_paths_list.add(args[i]);
+	}
+
+	String[] relative_file_paths = (String[]) relative_file_paths_list.toArray(new String[0]);
+	ZipTools.zipFiles(zip_file_path, base_directory_path, relative_file_paths);
+    }
+}
Index: trunk/gli/src/org/greenstone/gatherer/shell/GShell.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/shell/GShell.java	(revision 10691)
+++ trunk/gli/src/org/greenstone/gatherer/shell/GShell.java	(revision 10726)
@@ -66,4 +66,5 @@
     /** A flag used to determine if this process has been asked to cancel. */
     private boolean cancel = false;
+    private BufferedOutputStream buffered_output_stream = null;
     /** The list of listeners associated with this class. */
     private EventListenerList listeners = null;
@@ -158,30 +159,30 @@
 
 
-    protected boolean got_stream_char(InputStreamReader isr, StringBuffer line_buffer,
-				      BufferedOutputStream bos) throws IOException 
-    {
-	// Hopefully this doesn't block if the process is trying to write to STDOUT/STDERR.
-
-	boolean input_status = false;
-
-	if(isr.ready()) {
-	    input_status = true;
-	    int c = isr.read();
-	    if(c == '\n' || c == '\r') {
-		if(line_buffer.length() > 0) {
-		    String line = line_buffer.toString();
-		    DebugStream.println("* " + line + " *");
-		    fireMessage(type, typeAsString(type) + "> " + line, status, bos);
-		    line = null;
-		    line_buffer = new StringBuffer();
-		}
-	    }
-	    else {
-		line_buffer.append((char)c);
-	    }
-	}
-
-	return input_status;
-    }
+//     protected boolean got_stream_char(InputStreamReader isr, StringBuffer line_buffer,
+// 				      BufferedOutputStream bos) throws IOException 
+//     {
+// 	// Hopefully this doesn't block if the process is trying to write to STDOUT/STDERR.
+
+// 	boolean input_status = false;
+
+// 	if(isr.ready()) {
+// 	    input_status = true;
+// 	    int c = isr.read();
+// 	    if(c == '\n' || c == '\r') {
+// 		if(line_buffer.length() > 0) {
+// 		    String line = line_buffer.toString();
+// 		    DebugStream.println("* " + line + " *");
+// 		    fireMessage(type, typeAsString(type) + "> " + line, status, bos);
+// 		    line = null;
+// 		    line_buffer = new StringBuffer();
+// 		}
+// 	    }
+// 	    else {
+// 		line_buffer.append((char)c);
+// 	    }
+// 	}
+
+// 	return input_status;
+//     }
 
 
@@ -221,184 +222,44 @@
 	return error_count;
     }
-	    
-
-    protected void runRemote(String[] args, BufferedOutputStream bos) 
+
+
+    private void runRemote(String[] args, BufferedOutputStream bos)
     {
-	System.err.println("The level of design processing needed is: " + CollectionDesignManager.getRebuildTypeRequired()); //Will add smart design processing
-	if(hasSignalledStop()) { return; }
-	int error_count = 0;
-	StringBuffer error_list = new StringBuffer();
+	// Make sure the process hasn't been cancelled
+	if (hasSignalledStop()) {
+	    return;
+	}
+
 	try {
-	    if (type == IMPORT) {
-		String col_name = args[args.length-1];
-		if (progress!=null) {
-		    progress.messageOnProgressBar("Uploading data to server");
-		}
-
-		String collect_directory_path = Gatherer.getCollectDirectoryPath();
-		
-		//Only upload the parts of the import folder (files/metadata) that has been changed.
-		//Or upload the lot if we are doing a complete rebuild.
-		if(Gatherer.c_man.getCollection().getFilesChanged() || !Gatherer.g_man.create_pane.isIncremental()) {
-		    // zip up import folder, but exclude metadata
-		    ZipTools.zipup(collect_directory_path, col_name, "import", this, "", ".*metadata\\.xml");
-
-		    if(hasSignalledStop()) { return; }
-		    // upload it to gsdl server
-		    RemoteGreenstoneServer.upload_url_zip(col_name, "import", "files", this);
-
-		    Gatherer.c_man.getCollection().setFilesChanged(false);
-		    System.err.println("Finished uploading files");
-		}
-		if(Gatherer.c_man.getCollection().getMetadataChanged() || !Gatherer.g_man.create_pane.isIncremental()) {
-		    // zip up metadata from import folder
-		    ZipTools.zipup(collect_directory_path, col_name, "import", this, ".*metadata\\.xml", "");
-
-		    if(hasSignalledStop()) { return; }
-		    // upload it to gsdl server
-		    RemoteGreenstoneServer.upload_url_zip(col_name, "import", "metadata", this);
-		    Gatherer.c_man.getCollection().setMetadataChanged(false);
-		    System.err.println("Finished uploading metadata.");
-		}
-		
-		if(hasSignalledStop()) { return; }
-		// upload etc folder to server (need collect.cfg and any hfiles)
-		ZipTools.zipup(collect_directory_path, col_name, "etc", this, "", "");
-
-		if(hasSignalledStop()) { return; }
-		RemoteGreenstoneServer.upload_url_zip(col_name, "etc", "", this);
-
-		String collection_directory_path = Gatherer.c_man.getCollectionDirectoryPath(col_name);
-		File img_dir = new File(Gatherer.c_man.getCollectionImagesDirectoryPath());
-		if (img_dir.exists() && img_dir.list().length > 0) {
-		    // upload images/ directory to server
-		    if(hasSignalledStop()) { return; }
-		    ZipTools.zipup(collect_directory_path, col_name, "images", this, "", "");
-
-		    if(hasSignalledStop()) { return; }
-		    RemoteGreenstoneServer.upload_url_zip(col_name, "images", "", this);
-
-		    System.err.println("collect_directory_path: " + collect_directory_path);
-		    System.err.println("col_name: " + col_name);
-		}
-
-		if(hasSignalledStop()) { return; }
-		// see if collection specific image needs uploading
-		CollectionMetaManager cmm 
-		    = CollectionDesignManager.collectionmeta_manager;
-		
-		CollectionMeta icon_collection_collectionmeta 
-		    = cmm.getMetadatum(CollectionConfiguration.COLLECTIONMETADATA_ICONCOLLECTION_STR);
-		CollectionMeta icon_collection_small_collectionmeta 
-		    = cmm.getMetadatum(CollectionConfiguration.COLLECTIONMETADATA_ICONCOLLECTIONSMALL_STR);
-		
-		String ics_text = icon_collection_collectionmeta.getValue(CollectionMeta.TEXT);
-		String icsc_text = icon_collection_small_collectionmeta.getValue(CollectionMeta.TEXT);
-		if ((ics_text != null) && (ics_text != "")) {
-		    // Stub code for detecting when collectoin image changed
-		    // => need to upload images
-		    // System.err.println("**** ics_text = " + ics_text);
-		}
-		
-		if (progress!=null) {
-		    progress.messageOnProgressBar("");
-		}
-	    }
-	    
-	    if(hasSignalledStop()) { return; }
-	    String perl_cmd = args[0];
-	    int perl_cmd_root = perl_cmd.lastIndexOf(File.separator);
-	    
-	    if (perl_cmd_root > 0) {
-		String perl_cmd_cut = perl_cmd.substring(perl_cmd_root+1);
-		perl_cmd = perl_cmd_cut;
-	    }
-
-	    String cols_concat = null;
-	    String launch  = Gatherer.cgiBase + "launch";
-	    launch = launch + "?cmd=" + perl_cmd;
-	    
-	    for(int i = 1; i<args.length; i++) {
-		
-		String arg = args[i];
-		
-		if (arg.equals("-collectdir") || arg.equals("-importdir")
-		    || arg.equals("-builddir")) {
-		    // skip it
+	    int directory_name_end = args[0].lastIndexOf(File.separator);
+	    String script_name = ((directory_name_end != -1) ? args[0].substring(directory_name_end + 1) : args[0]);
+	    System.err.println("Script name: " + script_name);
+	    String collection_name = args[args.length - 1];
+	    System.err.println("Collection name: " + collection_name);
+
+	    String script_args = "";
+	    for (int i = 1; i < (args.length - 1); i++) {
+		// Skip arguments that won't make sense on the server
+		if (args[i].equals("-collectdir") || args[i].equals("-importdir") || args[i].equals("-builddir")) {
 		    i++;
 		    continue;
 		}
-				
-		if(arg.startsWith(StaticStrings.MINUS_CHARACTER)) {
-		    String name = arg.substring(1);
-		    launch = launch + "&" + name + "=";
-		    if (i+1<args.length-1) {
-			if (!args[i+1].startsWith(StaticStrings.MINUS_CHARACTER)) {
-			    i++;
-			    String val = URLEncoder.encode(args[i],"UTF-8");
-			    launch = launch + val;
-			}
+
+		// Script arguments get changed to CGI arguments
+		if (args[i].startsWith("-")) {
+		    script_args += "&" + args[i].substring(1) + "=";
+		    if ((i + 1) < (args.length - 1) && !args[i + 1].startsWith("-")) {
+			script_args += URLEncoder.encode(args[i + 1], "UTF-8");
+			i++;
 		    }
 		}
-		else {
-		    if (cols_concat==null) {
-			cols_concat = arg;
-		    }
-		    else {
-			cols_concat = cols_concat + ":" + arg;
-		    }
-		}
-	    }
-
-	    if (cols_concat!=null) {
-		launch = launch + "&c=" + cols_concat;
-	    }
-
-	    System.err.println("**** launch url = " + launch);
-	    // fireMessage(type, Dictionary.get("GShell.Command") + ": " + launch, status, null); // ****
-	    
-	    URL launch_url = new URL(launch);
-	    URLConnection launch_connection = launch_url.openConnection();
-	    InputStream stdis = launch_connection.getInputStream();
-	    InputStreamReader stdisr = new InputStreamReader(stdis, "UTF-8");
-	    
-	    BufferedReader stdbr = new BufferedReader(stdisr);
-	    
-	    if (type == GShell.NEW) {
-		while(true) {
-		    String line = stdbr.readLine();
-		    if (line == null) { break; }
-		    error_count = check_for_error(line,error_list,error_count);
-		}
-	    }
-	    else {
-		while(!hasSignalledStop()) {
-		    String line = stdbr.readLine();
-		    if (line == null) { break; }
-		    error_count = check_for_error(line,error_list,error_count);
-		    fireMessage(type, typeAsString(type) + "> " + line, status, bos);
-		}
-	    }
-	    stdbr.close();
-	    
-	    if (error_count>0) {
-		status = ERROR;
-		System.err.println(error_list);
-		if (type != GShell.NEW) {
-		    fireMessage(type, typeAsString(type) + "> " + error_list, status, null);
-		}
-	    }
-	    else if(hasSignalledStop()) {
-		//User pressed the cancel button.
-		//Status already set in hasSignalledStop method.
-	    }
-	    else {
-		status = OK;
-		fireMessage(type, typeAsString(type) + "> " + Dictionary.get("GShell.Success"), status, null);
-	    }
-	}
-	// Exception
+	    }
+
+	    System.err.println("Script args: " + script_args);
+	    buffered_output_stream = bos;
+	    String command_output = RemoteGreenstoneServer.runScript(collection_name, script_name, script_args, this);
+	    status = (command_output.equals("") ? CANCELLED : OK);
+	}
 	catch (Exception exception) {
-	    System.err.println("Exception in GShell.runRemote() - unexpected");
 	    DebugStream.printStackTrace(exception);
 	    status = ERROR;
@@ -407,5 +268,5 @@
 
 
-    protected void runLocal(String[] args, BufferedOutputStream bos) 
+    private void runLocal(String[] args, BufferedOutputStream bos) 
     {
 	try {
@@ -415,5 +276,5 @@
 	    }
 	    
-	    DebugStream.println("Command: "+command);
+	    System.err.println("Command: "+command);
 	    ///ystem.err.println("Command: " + command);
 	    fireMessage(type, Dictionary.get("GShell.Command") + ": " + command, status, null);
@@ -543,5 +404,7 @@
 
 	// Issue a processBegun event
+	System.err.println("\nFiring process begun for " + type + "...");
 	fireProcessBegun(type, status);
+	System.err.println("Done process begun.");
 	if (Gatherer.isGsdlRemote) {
 	    runRemote(args,bos);
@@ -550,12 +413,10 @@
 	    runLocal(args,bos);
 	}
+	System.err.println("Done runLocal().");
 
 	if(status == OK) {
 	    if (type == NEW) {
 		if (Gatherer.isGsdlRemote) {
-		    RemoteGreenstoneServer.download_url_zip(col_name, ".", this, "", "");
-		    if (!hasSignalledStop()) {
-			ZipTools.unzip(Gatherer.getCollectDirectoryPath(), col_name);
-		    }
+		    RemoteGreenstoneServer.downloadCollection(col_name);
 		}
 	    }
@@ -569,24 +430,6 @@
 		    }
 
-		    Utility.delete(Gatherer.c_man.getCollectionArchivesDirectoryPath()); // remove current archives
-		    //new File(Gatherer.c_man.getCollectionArchivesDirectoryPath()).mkdir(); //Make a clean dir
-		    RemoteGreenstoneServer.download_url_zip(col_name, "archives", this, ".*doc\\.xml", "");
-		    if (hasSignalledStop()) {
-			// Clean up, then exit
-			fireProcessComplete(type, status);
-			// Close bos
-			if(bos != null) {
-			    try {
-				bos.close();
-				bos = null;
-			    }
-			    catch(Exception error) {
-				DebugStream.printStackTrace(error);
-			    }
-			}
-			return;
-		    }
-		    ZipTools.unzip(Gatherer.getCollectDirectoryPath(), col_name);
-		    
+		    RemoteGreenstoneServer.downloadCollectionArchives(col_name);
+
 		    if (progress!=null) {
 			progress.messageOnProgressBar("");
@@ -608,11 +451,7 @@
  		    }
 
-		    File buildDir = new File(Gatherer.c_man.getCollectionBuildingDirectoryPath());
- 		    Utility.delete(buildDir); // remove current build dir
-		    //Only need build.cfg
-		    RemoteGreenstoneServer.download_url_zip(col_name, "building", this, ".*build\\.cfg", "");
-		    if (!hasSignalledStop()) {
-			ZipTools.unzip(Gatherer.getCollectDirectoryPath(), col_name);
-		    }
+		    // Only need to download build.cfg file
+		    File build_cfg_file = new File(Gatherer.c_man.getCollectionBuildingDirectoryPath(), "build.cfg");
+		    RemoteGreenstoneServer.downloadCollectionFile(col_name, build_cfg_file);
 		    
  		    if (progress!=null) {
@@ -638,4 +477,5 @@
 
 	// We're done.	
+	System.err.println("Firing process complete for " + type + "...");
 	fireProcessComplete(type, status);
 	// Close bos
@@ -650,4 +490,12 @@
 	}
     }
+
+
+    public void fireMessage(String message)
+    {
+	fireMessage(type, typeAsString(type) + "> " + message, status, buffered_output_stream);
+    }
+
+
     /** Method for firing a message to all interested listeners.
      * @param type An <strong>int</strong> indicating the process type.
@@ -697,5 +545,7 @@
 	// Start the progres monitor if available
 	if(progress != null) {
+	    System.err.println("About to call progress.start().");
 	    progress.start();
+	    System.err.println("Called progress.start().");
 	}
 	// Fire an event
